#!/usr/bin/env python
#-*- coding: utf-8 -*-

#Importe
import os
import sys
import pickle

from PySide import QtCore
from PySide.QtCore import Qt
from PySide import QtGui
from PySide import QtDeclarative
from PySide import QtOpenGL

class countmee():
    def __init__(self):

        #Oberfläche und Instanzierungen für QML2Py Funktionen
        self.view = QtDeclarative.QDeclarativeView()

        #OpenGL Rendering
        self.glw = QtOpenGL.QGLWidget()
        self.view.setViewport(self.glw)

        self.view.setSource(QtCore.QUrl('/opt/CountMeePro/qml/main.qml'))
        self.root = self.view.rootObject()

        #instantiate the Python object
        self.pyfunc = pyfunc()

        #expose the object to QML
        self.context = self.view.rootContext()
        self.context.setContextProperty("pyfunc", self.pyfunc)

        self.pyfunc.saveData.connect(self.saveData)
        self.pyfunc.showData.connect(self.showData)
        self.pyfunc.loadData.connect(self.loadData)
        self.pyfunc.deleteData.connect(self.deleteData)


    def saveData(self, name, result, timeMS, timeReal):
        #Prüfen der Save-Pfade, sonst anlegen der Datei!
        if os.path.isfile('/home/user/.config/countmee.sav') == True:
            #Laden der gespeicherten Werte
            f = open("/home/user/.config/countmee.sav")
            l = pickle.load(f)

        else:
            #erstellen einer entsprechenden sav mit pickle
            f = open("/home/user/.config/countmee.sav", "w")
            pickle.dump({"name":[], "results":[], "timeMS":[], "timeReal":[]}, f)
            f = open("/home/user/.config/countmee.sav")
            l = pickle.load(f)

        if name == "":
            name = "DEFAULT"

        if timeMS == 0:
            timeReal = "--:--:--"

        names = l["name"]
        names.append(name)
        numbers = l["results"]
        numbers.append(result)
        timesMS = l["timeMS"]
        timesMS.append(timeMS)
        timesReal = l["timeReal"]
        timesReal.append(timeReal)

        #Speichern der Daten
        f = open("/home/user/.config/countmee.sav", "w")
        pickle.dump(l,f)
        self.root.savedSuccessful()


    def showData(self):
        #Laden der gespeicherten Daten
        if os.path.isfile('/home/user/.config/countmee.sav') == True:
            f = open("/home/user/.config/countmee.sav")
            l = pickle.load(f)

            #Listen mit Namen und Zählerständen werden gebildet und übergeben
            nameList = l["name"]
            resultList = l["results"]
            timeRealList = l["timeReal"]
            self.root.create_dataList(nameList, resultList, timeRealList)

        #Falls keine Daten vorhanden, auslösen eines QML-Warndialogs
        else:
            self.root.noData()


    def loadData(self, index):
        #Laden der gespeicherten Daten
        f = open("/home/user/.config/countmee.sav")
        l = pickle.load(f)

        #Daten werden in Listen geladen und QML übergeben. 
        #Name ist NICHT in UI! Daher nicht geladen.
        loadResult = l["results"]
        loadResult = loadResult[index]
        loadResult = str(loadResult)
        loadTimeReal = l["timeReal"]
        loadTimeReal = loadTimeReal[index]
        loadTimeReal = str(loadTimeReal)
        loadTime = l["timeMS"]
        loadTime = loadTime[index]
        loadTime = int(loadTime)

        self.root.set_loadedData(loadResult, loadTimeReal, loadTime)


    def deleteData(self, index):
        #Laden der gespeicherten Werte
        f = open("/home/user/.config/countmee.sav")
        l = pickle.load(f)

        #Daten werden aus dem Dictionary entfernt
        nameList = l["name"]
        resultList= l["results"]
        timeList = l["timeMS"]
        timeListReal = l["timeReal"]
        nameList.pop(index)
        resultList.pop(index)
        timeList.pop(index)
        timeListReal.pop(index)

        #Speichern der Daten
        f = open("/home/user/.config/countmee.sav", "w")
        pickle.dump(l,f)

        self.root.deletedSuccessful()

# Klasse für Funktionen die aus QML heraus angesprochen werden sollen:
class pyfunc(QtCore.QObject):
    saveData = QtCore.Signal(str, str, int, str)
    showData = QtCore.Signal()
    loadData = QtCore.Signal(int)
    deleteData = QtCore.Signal(int)

    def __init__(self):
        QtCore.QObject.__init__(self)

#Starten der App
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    start = countmee()
    start.view.showFullScreen()
    sys.exit(app.exec_())
