import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    orientationLock: PageOrientation.LockPortrait
    tools: commonTools

    property alias resultToSave: resultToSave.text
    property alias saveNameField: saveNameField.text
    property alias dataList: dataList

    Dialogs {
        id: dialogs
    }

    ToolBarLayout {
        id: commonTools
        visible: true

        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                pageStack.pop()
            }
        }
    }

    Rectangle {
        id: bgcolor
        anchors.fill: parent
        color: "black"
        opacity: 0.85
    }

    Text {
        id: saveTitle
        anchors {top: parent.top; topMargin: 10; left: parent.left; leftMargin: 20}
        text: "save & load"
        font {family: "Nokia Pure Text Light"; pointSize: 40}
        color: "lightgrey"
    }

    Text {
        id: setSaveTitle
        anchors {top: parent.top; topMargin: 100; left: parent.left; leftMargin: 18}
        text: "You've counted so far:"
        font {family: "Nokia Pure Text Light"; pointSize: 18}
        color: "lightgrey"
    }

    Text {
        id: resultToSave
        anchors {top: parent.top; topMargin: 140; horizontalCenter: parent.horizontalCenter}
        text: mainPage.zahl
        font {family: "Nokia Pure Text Light"; pointSize: 50}
        color: "lightgrey"
    }

    Text {
        id: setTimeTitle
        anchors {top: parent.top; topMargin: 225; left: parent.left; leftMargin: 18}
        text: "Your time:"
        font {family: "Nokia Pure Text Light"; pointSize: 18}
        color: "lightgrey"
    }

    Text {
        id: timeToSave
        anchors {top: parent.top; topMargin: 265; horizontalCenter: parent.horizontalCenter}
        text: mainPage.countdownText.substr(7,15)
        font {family: "Nokia Pure Text Light"; pointSize: 50}
        color: "lightgrey"
    }

    TextField {
        id: saveNameField
        anchors {top: parent.top; topMargin: 350; horizontalCenter: parent.horizontalCenter}
        width: parent.width-50
        maximumLength: 20
        placeholderText: "Give your result a name..."
        text: ""
    }

    Button {
        id: saveButton
        anchors {top: parent.top; topMargin: 425; horizontalCenter: parent.horizontalCenter}
        text: "Save"
        platformStyle: ButtonStyle {inverted: true}
        onClicked: {
            pyfunc.saveData(saveNameField.text, mainPage.zahl, mainPage.countdownTime, timeToSave.text)
        }
    }

    Button {
        id: loadButton
        anchors {top: parent.top; topMargin: 495; horizontalCenter: parent.horizontalCenter}
        text: "Load"
        platformStyle: ButtonStyle {inverted: true}
        onClicked: {
            pyfunc.showData()
            dialogs.loadDialog.open()
        }
    }

    //it's called everytime the saved objects need to be shown!
    ListModel {
        id: dataList
    }

    Button {
        id: deleteButton
        anchors {top: parent.top; topMargin: 630; horizontalCenter: parent.horizontalCenter}
        text: "Delete"

        platformStyle: ButtonStyle{
            background: "image://theme/color14-meegotouch-button-accent-background"+(position?"-"+position:"")
            pressedBackground: "image://theme/color14-meegotouch-button-background-pressed" + (position ? "-" + position : "")
            textColor: "white"
        }

        onClicked: {
            pyfunc.showData()
            dialogs.deleteDialog.open()
        }
    }
}
