import QtQuick 1.1
import com.nokia.meego 1.0

Page {
    orientationLock: PageOrientation.LockPortrait
    tools: commonTools

    ToolBarLayout {
        id: commonTools
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                pageStack.pop()
                if (fieldStep.text !== "") {mainPage.stepSize = fieldStep.text; fieldStep.text = ""};
                if (fieldCounter.text !== "") {mainPage.zahl = fieldCounter.text; fieldCounter.text = ""}

                if (soundSwitch.checked !== true) {mainPage.sound = false}
                else {mainPage.sound = true}
                if (vibraSwitch.checked !== true) {mainPage.vibra = false}
                else {mainPage.vibra = true}
            }
        }
    }

    Rectangle {
        id: bgcolor
        anchors.fill: parent
        color: "black"
        opacity: 0.85
    }

    Text {
        id: settingsTitle
        anchors {top: parent.top; topMargin: 10; left: parent.left; leftMargin: 20}
        text: "settings"
        font {family: "Nokia Pure Text Light"; pointSize: 50}
        color: "lightgrey"

    }

    Text {
        id: setCounterTitle
        anchors {top: parent.top; topMargin: 100; left: parent.left; leftMargin: 18}
        text: "Set your counter to: (max. 6)"
        font {family: "Nokia Pure Text Light"; pointSize: 20}
        color: "lightgrey"
    }

    TextField {
        id: fieldCounter
        anchors {top: parent.top; topMargin: 150; horizontalCenter: parent.horizontalCenter}
        width: parent.width-50
        maximumLength: 6
        placeholderText: "0"
        errorHighlight: !acceptableInput
        validator: IntValidator{bottom: 0; top: 999999}
    }

    Text {
        id: setStepTitle
        anchors {top: parent.top; topMargin: 225; left: parent.left; leftMargin: 18}
        text: "Set your step size to: (max. 4)"
        font {family: "Nokia Pure Text Light"; pointSize: 20}
        color: "lightgrey"
    }

    TextField {
        id: fieldStep
        anchors {top: parent.top; topMargin: 275; horizontalCenter: parent.horizontalCenter}
        width: parent.width-50
        maximumLength: 4
        placeholderText: "0"
        errorHighlight: !acceptableInput
        validator: IntValidator{bottom: 0; top: 9999}
    }

    Switch {
        id: soundSwitch
        anchors {top: parent.top; topMargin: 350; left: parent.left; leftMargin: 20}
        checked: true

        Text {
            id: soundText
            anchors {horizontalCenter: soundSwitch.horizontalCenter; left: soundSwitch.right; leftMargin: 20}
            font {pointSize: 20; family: "Nokia Pure Text Light"}
            text: "sound on clicked"
            color: "lightgrey"
        }
    }

    Switch {
        id: vibraSwitch
        anchors {top: parent.top; topMargin: 425; left: parent.left; leftMargin: 20}
        checked: true

        Text {
            id: vibraText
            anchors {horizontalCenter: vibraSwitch.horizontalCenter; left: vibraSwitch.right; leftMargin: 20}
            font {pointSize: 20; family: "Nokia Pure Text Light"}
            text: "vibration on clicked"
            color: "lightgrey"
        }
    }
}
